<?php
namespace nur\sery\db;

/**
 * Class Capacitor: un objet permettant d'attaquer un canal spécique d'une
 * instance de {@link CapacitorStorage}
 */
class Capacitor {
  function __construct(CapacitorStorage $storage, CapacitorChannel $channel) {
    $this->storage = $storage;
    $this->channel = $channel;
  }

  /** @var CapacitorStorage */
  protected $storage;

  /** @var CapacitorChannel */
  protected $channel;

  function exists(): bool {
    return $this->storage->_exists($this->channel);
  }

  function reset(): void {
    $this->storage->_reset($this->channel);
  }

  function charge($item, ?callable $func=null, ?array $args=null): bool {
    return $this->storage->_charge($this->channel, $item, $func, $args);
  }

  function discharge($filter=null, ?bool $reset=null): iterable {
    return $this->storage->_discharge($this->channel, $filter, $reset);
  }

  function get($filter) {
    return $this->storage->_get($this->channel, $filter);
  }

  function each($filter, callable $func, ?array $args=null): void {
    $this->storage->_each($this->channel, $filter, $func, $args);
  }

  function close(): void {
    $this->storage->close();
  }
}
