<?php
namespace nur\sery\db;

/**
 * Class CapacitorChannel: un canal d'une instance de {@link ICapacitor}
 */
class CapacitorChannel {
  const NAME = null;

  static function verifix_name(?string $name): string {
    if ($name === null) $name = "default";
    return strtolower($name);
  }

  function __construct(?string $name=null) {
    $this->name = self::verifix_name($name ?? static::NAME);
    $this->created = false;
  }

  /** @var string */
  protected $name;

  function getName(): string {
    return $this->name;
  }

  function getTableName(): string {
    return $this->name."_channel";
  }

  protected $created;

  function isCreated(): bool {
    return $this->created;
  }

  function setCreated(bool $created=true): void {
    $this->created = $created;
  }

  /**
   * retourner un ensemble de définitions pour des colonnes supplémentaires à
   * insérer lors du chargement d'une valeur
   *
   * la colonne "_id" de définition "integer primary key autoincrement" est la
   * clé primaire par défaut. elle peut être redéfinie, et dans ce cas la valeur
   * à utiliser doit être retournée par {@link getKeyValues()}
   */
  function getKeyDefinitions(): ?array {
    return null;
  }

  /**
   * calculer les valeurs des colonnes supplémentaires à insérer pour le
   * chargement de $item
   *
   * Si "_id" est retourné, la ligne existante est mise à jour le cas échéant.
   */
  function getKeyValues($item): ?array {
    return null;
  }
}
